import randomColor from "randomcolor";

export default class {

  constructor(x, y , r, speed, color = null, borderColor = null) {
    this.x = x;
    this.y = y;
    this.r = r;
    this.color = color || randomColor();
    this.borderColor = borderColor || this.color;
    this.speed = speed;
  }

  draw(ctx) {
    ctx.beginPath();
    ctx.fillStyle = this.color;
    ctx.strokeStyle = this.borderColor;
    ctx.arc(this.x, this.y, this.r, 0, 2 * Math.PI);
    ctx.closePath();
    ctx.fill();
    ctx.stroke();
  }

  move(angle, deltaT) {
    let distX = this.speed * deltaT * Math.cos(angle);
    let distY = this.speed * deltaT * Math.sin(angle);
    this.x += distX;
    this.y += distY;
  }

  compareToCircle(c) {
    return this.r - c.r;
  }

  isCollidingWith(c) {
    return Math.pow(c.x - this.x, 2) + Math.pow(c.y - this.y, 2) <= Math.pow(this.r + c.r, 2);
  }

}